/**********************************************************
 * Headerfile...: etext.h                                 *
 * Zweck........: Einfache Textberabeitungsroutinen       *
 **********************************************************/
/**********************************************************
 * Funktion....: chop                                     *
 * Parameter...: str: Zeiger auf '\0'-Terminierten String *
 * Liefert.....: letztes Zeichen des Strings              *
 * Zweck.......: entfernt letztes Zeichen                 *
 **********************************************************/
char chop(char *str);
/******************************************************************************
 * Funktion....: splitt                                                       *
 * Parameter...: zeile : zu zerlegende Zeile                                  *
 *               trenn : Trenzeichen                                          *
 *               feld  : Array von char* mu gengend lang allokiert sein     *
 * liefert.....: Zahl der felder                                              *
 * Zweck.......: Splittet Zeile in Felder auf, die durch trenn getrennt sind. *
 *               trenn wird mit '\0' ersetzt. Die Zeiger von feld zeigen auf  *
 *               den Anfang der Felder.                                       *
 *               Das Feld zeile wird modifiziert !                            *
 *****************************************************************************/
int splitt(char *zeile,char trenn,char **feld);

/******************************************************************************
 * Funktion.....: trim                                                        *
 * Parameter....: str : String                                                *
 * Zweck........: entfernt Fhrfernde und folgende whitespaces von str        *
 *****************************************************************************/
char *trim(char *str);

/* Zweck..: Kopiert max. l-1 zeichnen von quelle nach ziel 
            und schliest ziel mit '\0' ab
   liefert: letztes kopiertes zeichen von quelle
 */
char copystrhin(char *ziel,int l,char *quelle);

/***************************************************************************
 * Funktion...: leer                                                       *
 * Parameter..: str : String                                               *
 * Zweck......: schaut, ob zeichenkette nur Leerzeichen enthaelt           *
 ***************************************************************************/
int leer(char *str);

 




