#include<iostream.h>
#include<stdlib.h>
#include<ctype.h>
#include<assert.h>
#include"zeit.h"

const char PT_ZAHL[]="Zahl erwartet";
const char PT_SYNTAX[] = "Syntax-error";
const char PT_TAG[] = "Bedingung 1<=TAG <=31 verletzt";
const char PT_MONAT[] = "Bedingung 1<= MONAT <=12 verletzt";

char *wochentag[7]={"So","Mo","Di","Mi","Do","Fr","Sa"};

const char *Datum::parse(const char *str,const char **pos)
{
  const char *p = str;
  const char *e=str;
  int f = 0;
  int erg;

  while((isdigit(*e) || *e == '.') && f<3)
  {
    erg=(int)strtol(e,&p,10);
    if(p==e) return PT_ZAHL;
    if(*p != '.' && f < 2) return PT_SYNTAX; 
    switch(f)
    {
    case 0: // Tag
        if(erg < 1 || erg > 31) return PT_TAG;
	tag = erg;
   	e = p+1;
        break;
    case 1: // Monat
	if(erg < 1 || erg > 12) return PT_MONAT;
	monat = erg;
        e = p+1;
        break;
    case 2: // Jahr
	jahr = ( erg < 100 ? 1900+erg : erg);
        e = p;
	break;
    }
    f++;
  }
  if(f < 3) return PT_ZAHL;
  if(pos != NULL) *pos = p;
  return (char *)0;
}

Datum &Datum::operator++()
{
    if(tag < monatlang(jahr,monat)) tag++;
    else
    {
	tag=1;
	if(monat < 12) monat++;
        else
	{
	    monat=1;
            jahr++;
	}
    }
    return *this;
}

int Datum::operator-(const Datum& von) const
{
  int ret;
  int w=0;
  int bj,ej;
  assert(cmp(von)>=0);
  if(monat==von.monat && jahr == von.jahr) ret=tag-von.tag;
  else
  {
      ret = tag + monatlang(von.jahr,von.monat)-von.tag;
      int m=von.monat+1;
      int bj = von.jahr;
      if(m==13) { m = 1; bj = jahr; w=1;}
      while(m!=monat || bj != jahr)
      {
          //cout << "m " << m << '/' << bj << endl;
	  ret += monatlang(bj,m);
	  if(++m==13) { m = 1; bj = jahr; w=1;}
      }
  }

  for(int j= von.jahr+1;j< jahr;j++) 
  {
      //cout << j << "\n";
      ret += (schaltjahr(j) ? 366 : 365);
  }
  return ret;
}

Datum Datum::operator+(int ab)
{
    Datum ret=*this;
    // Saudumm _implementierung
    for(int i=0;i<ab;i++)
    {
	++ret;
    }
    return ret;
}


int heutig(Datum &h)
{
  struct timeval tv;
  struct tm *tm;
  time_t lt;
  gettimeofday(&tv,NULL);
  lt=tv.tv_sec;
  tm=localtime(&lt);

  h.tag=tm->tm_mday;h.monat=tm->tm_mon+1;h.jahr=tm->tm_year;
  return tm->tm_wday;
}

#ifdef ZEITTEST
#include<time.h> 
int main(int argc,char **argv)
{
    if(argc == 3)
    {
	char *p;
	Datum datv,datb;
	int ab;
	const char *ret;
	ret = datv.parse(argv[1],&p);
	if(ret !=0 ) { cerr << ret << " in " << argv[1] <<  endl; exit(1);}
	cout << "Von ";datv.print(cout);cout << endl;
	ret = datb.parse(argv[2],&p);
	if(ret !=0 ) { cerr << ret << " in " << argv[2] <<  endl; exit(1);}
	cout << "Bis ";datb.print(cout);cout << endl;
	
	ab = datb-datv;
	
	cout << "Zahl der Tage = " << ab << endl;

	Datum dat = datv+ab;
	dat.print(cout);
        if(datb.cmp(dat)!=0) cout << " FALSCH !!!!";
        cout << "\n";
    }
    else if(argc == 2)
    {
	const char *ret;
        char *p;
	Datum dat;
        time_t z;
        ret = dat.parse(argv[1],&p);
	if(ret !=0 ) { cerr << ret << " in " << argv[1] <<  endl; exit(1);}
	z = sekzeit(dat);
        dat.print(cout);
        cout << " Zeit in Sek: " << z << endl;
        cout << "ctime: " << ctime(&z) << endl;
    }
}  
#endif












